// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GIOMM_FILTERINPUTSTREAM_H
#define _GIOMM_FILTERINPUTSTREAM_H


#include <glibmm.h>

// -*- Mode: C++; indent-tabs-mode: nil; c-basic-offset: 2 -*-

/* Copyright (C) 2008 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <giomm/inputstream.h>
#include <glibmm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GFilterInputStream GFilterInputStream;
typedef struct _GFilterInputStreamClass GFilterInputStreamClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gio
{ class FilterInputStream_Class; } // namespace Gio
namespace Gio
{

//TODO: Proper documentation.

/** Filter Input Stream.
 *
 * @ingroup Streams
 *
 * @newin2p16
 */

class FilterInputStream : public Gio::InputStream
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef FilterInputStream CppObjectType;
  typedef FilterInputStream_Class CppClassType;
  typedef GFilterInputStream BaseObjectType;
  typedef GFilterInputStreamClass BaseClassType;

private:  friend class FilterInputStream_Class;
  static CppClassType filterinputstream_class_;

private:
  // noncopyable
  FilterInputStream(const FilterInputStream&);
  FilterInputStream& operator=(const FilterInputStream&);

protected:
  explicit FilterInputStream(const Glib::ConstructParams& construct_params);
  explicit FilterInputStream(GFilterInputStream* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~FilterInputStream();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GFilterInputStream*       gobj()       { return reinterpret_cast<GFilterInputStream*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GFilterInputStream* gobj() const { return reinterpret_cast<GFilterInputStream*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GFilterInputStream* gobj_copy();

private:

public:
  
  /** Gets the base stream for the filter stream.
   * @return A InputStream.
   */
  Glib::RefPtr<InputStream> get_base_stream();

  
  /** Gets the base stream for the filter stream.
   * @return A InputStream.
   */
  Glib::RefPtr<const InputStream> get_base_stream() const;

  #ifdef GLIBMM_PROPERTIES_ENABLED
/** The underlying base stream the io ops will be done on.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly< Glib::RefPtr<InputStream> > property_base_stream() const;
#endif //#GLIBMM_PROPERTIES_ENABLED


public:

public:
  //C++ methods used to invoke GTK+ virtual functions:
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

  //Default Signal Handlers::
#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


};

} // namespace Gio


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gio::FilterInputStream
   */
  Glib::RefPtr<Gio::FilterInputStream> wrap(GFilterInputStream* object, bool take_copy = false);
}


#endif /* _GIOMM_FILTERINPUTSTREAM_H */

